/****************************************************************************
*
*   Copyright (c) 2007 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
*	ERP v1, June 17th, 2007
*
*
****************************************************************************/

//SoR Include
#include "SoR_Utils.h" //includes all the technical stuff
#include "ERP_motions.h" //includes kinematics for ERP
#include "radial_firewall.h" //includes algorithm and map for radial firewall
//#include "CMUcam.h" //includes everything for the CMUcam


//target location, determined by sensors
int target_X=0;
int target_Y=0;
int target_Z=0;

//arm position
int arm_end_X=0;//end effector location
int arm_end_Y=0;
int arm_end_Z=0;
int arm_J1_angle=0;//joint angles
int arm_J2_angle=0;
int arm_J3_angle=0;

//range finder variables
int rangefinder=0;
int nearest_target=0;//alpha of closest object
int closest_distance=0;//distance of closest object

//house map
/*int house_map[3][3]={0,0,0,
					 0,0,0,
					 0,0,0};*/


void scan_2D(void)
	{
	//get the robot ready for a scan (move arm out the way, etc)

	for(alpha=0;alpha<6;alpha++)//rotate from one far end to the other
		{
		rangefinder=a2dConvert8bit(5);
			
		//find angle to nearest target
		if (rangefinder > closest_distance)
			{
			closest_distance = rangefinder;
			nearest_target = cam_far_clockwise-alpha*6;
			}				

		for(i=0;i<10;i++)
			{
			cam_rotate(cam_far_clockwise-alpha*6);//go to next angle
			delay_cycles(500);
			}

		//update_map(rangefinder);

		//get camera data
		//do something with sensor data
		delay_cycles(1043);//allow for analog conversion time, and motion time
		}
	
	//cam_straight();//reset cam in center for a future use
	}

void scan_3D(void)
	{
	for(j=cam_far_down;j<cam_far_up;j+=cam_vert_scan_divisor)
		{
		//move cam up some
		for(i=0;i<10;i++)
			{
			cam_elevate(j);
			delay_cycles(500);
			}

		scan_2D();
		}
	}

int main(void)
	{
	//LED_off();
	initialize();
//	CMUcam_init();
	delay_cycles(20000);//delay time
	//LED_off();
	//rprintf("Initialization Complete\r\n");

	/*********ADD YOUR CODE BELOW THIS LINE **********/


	while(1)
		{

		//arm_J1(40);
		//arm_fold();
		//cam_straight();
		//demonstrate_drive();
		//demonstrate_arm();
		//hand_wave();
		//look_at_object();
		//scan_for_objects();
		//3D_scan();
		//cam_rotate(20);

		//prepare_for_scan();
		//scan_2D();

		//point_direction(nearest_target);

		rangefinder=a2dConvert8bit(5);//255 really close, 0 really far

		target_X=72;//0 is far left, 143 is far right
		target_Y=40;//80 is straight up, 0 is straight down

		//CMUcam and AVRcam have 80(Y) x 143(X) resolution
		arm_track(target_X, target_Y, rangefinder);
		
		//stab();



		//move arm wrt sensor
		//if(a2dConvert8bit(5) > 20 && a2dConvert8bit(5) < 70)
		//	arm_J3(a2dConvert8bit(5));

		
		//printf("Hello, World! Read My Analog: %u\r\n", sensor_0);//output message to serial (use hyperterminal)

	/*********ADD YOUR CODE ABOVE THIS LINE **********/
		delay_cycles(1000);//a small delay to prevent crazy oscillations
		}

	return 0;
	}
