/****************************************************************************
*
*   Copyright (c) 2007 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
*	ERP Radial Firewall Algorithm, June 23rd, 2007
*
****************************************************************************/


int m=0;//junk variable
int k=0;//junk variable

int alpha=0;
int distance=0;

int map_2D_radial[6][3];//a radial graph: alpha angle vs distance location


//creates a 6x3 radial map, 0 is robot location, 1 surrounds robot, and each row further increases by +1
void create_map(void)
	{
	for (m=0;m<6;m++)
		{
		for (k=0;k<3;k++)
			map_2D_radial[m][k]=k+1;
		}
	}

//inverts and linearizes rangefinder data into 3 parts
int linearize_ranger(int range_data)
	{
	if (range_data > 150)//close
		return 0;
	if (range_data > 70)//middle
		return 1;
	return 2;//far away
	}

//this adds obstacles to map, while automatically doing realtime radial firewall
void update_map(int range_data)
	{
	if (range_data > 2)//object is found
		{
		distance=linearize_ranger(range_data);//linearize ranger data

		//adding object to map
		map_2D_radial[alpha][distance]=111;//111 represents an object

		//updating firewall -> if object found, the space after becomes +1 higher
		if (distance > 0) //not next to robot
			map_2D_radial[alpha][distance+1]=map_2D_radial[alpha][distance-1]+2;
		else
			map_2D_radial[alpha][distance+1]=3;
		}
	}

/*
//update_map() already did a firewall, we just need to trace path from goal to robot
int find_path(void)
	{
	//given goal_alpha and goal_distance already

		//no obstacle in the way and firewall number increases
		if (map_2D_radial[goal_alpha][goal_distance-1] != 111 && map_2D_radial[alpha][distance-1] < map_2D_radial[alpha][distance])
			//store location //have robot move to that location
		if (map_2D_radial[goal_alpha-1][goal_distance] != 111 && map_2D_radial[alpha-1][distance] < map_2D_radial[alpha][distance])
			//store location //have robot move to that location
		if (map_2D_radial[goal_alpha+1][goal_distance] != 111 && map_2D_radial[alpha+1][distance] < map_2D_radial[alpha][distance])
			//store location //have robot move to that location
		

	return 0;//no solution found
	}
*/
